//---------------------------------------------------------------------------
#ifndef Unit2H
#define Unit2H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\Menus.hpp>
#include <vcl\FileCtrl.hpp>
#include <vcl\clipbrd.hpp>
//---------------------------------------------------------------------------
class TForm2 : public TForm
{
__published:	// IDE-managed Components
	TFindDialog *FindDlg;
	TReplaceDialog *ReplaceDlg;
	TPageControl *EditorPageControl;
	TRichEdit *MessageEdit;
	TStatusBar *StatusBar;
	TPanel *SplitPanel;
	TPopupMenu *PopupMenu;
	TMenuItem *PopupMenu_ClosePage;
	TMenuItem *PopupMenu_CloseAllPages;
	TMenuItem *N6;
	TMenuItem *PopupMenu_New;
	TMenuItem *PopupMenu_Open;
	TMenuItem *N2;
	TMenuItem *PopupMenu_Save;
	TMenuItem *PopupMenu_SaveAs;
	TMenuItem *PopupMenu_SaveAll;
	TMenuItem *N1;
	TMenuItem *PopupMenu_Find;
	TMenuItem *PopupMenu_Replace;
	TOpenDialog *FileOpenDlg;
	TFontDialog *FontDialog1;
	TMenuItem *N3;
	TMenuItem *Popup_Font_IDM;
    TSaveDialog *FileSaveDlg;
	void __fastcall FindDlgFind(TObject *Sender);
	void __fastcall ReplaceDlgReplace(TObject *Sender);
	
	void __fastcall SplitPanelMouseDown(TObject *Sender, TMouseButton Button,TShiftState Shift, int X, int Y);

	void __fastcall SplitPanelMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);

	void __fastcall SplitPanelMouseUp(TObject *Sender, TMouseButton Button,	TShiftState Shift, int X, int Y);

	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormHide(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);

    // autocreated richedit events
    void __fastcall RichEditChange(TObject* Sender);
	void __fastcall RichEditDragDrop(TObject *Sender, TObject *Source, int X, int Y);
	void __fastcall RichEditDragOver(TObject *Sender, TObject *Source, int X, int Y, TDragState State, bool &Accept);
	void __fastcall RichEditKeyUp(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall RichEditMouseDown(TObject *Sender, TMouseButton Button,TShiftState Shift, int X, int Y);
	
	void __fastcall RichEditSelectionChange(TObject *Sender);
    
	
	void __fastcall PopupMenu_ClosePageClick(TObject *Sender);
	void __fastcall PopupMenu_CloseAllPagesClick(TObject *Sender);
	void __fastcall PopupMenu_NewClick(TObject *Sender);
	void __fastcall PopupMenu_OpenClick(TObject *Sender);
	void __fastcall PopupMenu_SaveClick(TObject *Sender);
	void __fastcall PopupMenu_SaveAsClick(TObject *Sender);
	void __fastcall PopupMenu_SaveAllClick(TObject *Sender);
	void __fastcall PopupMenu_FindClick(TObject *Sender);
	void __fastcall PopupMenu_ReplaceClick(TObject *Sender);
	void __fastcall PopupMenuPopup(TObject *Sender);
	
	void __fastcall Popup_Font_IDMClick(TObject *Sender);
private:	// User declarations
	// the commented out declarations are obsolete now ...
//    TRichEdit* ActiveEditor;
//    void __fastcall UpdateActiveEditor();


	int SplitPanelDragging;
 	TPoint MaxPosition;
    TPoint MinTrack;
    TPoint MaxTrack;
    int    Untitleds;
    TRichEdit* NewRichEdit;
    TTabSheet* NewTabSheet;
    void __fastcall	OnGetMinMaxInfo(TWMGetMinMaxInfo& Message);

    void __fastcall UpdatePanels();

    void __fastcall UpdateMenuItems();
    void __fastcall UpdateToolbarButtons();
    void __fastcall UpdateStatus();

    void __fastcall NewRichEditSetup(TRichEdit* NewRE);

public:		// User declarations
    void __fastcall LoadFile(AnsiString FileName);

    //// methods called from the main forms menu
    void __fastcall NewTab();
    void __fastcall FileOpen();
 	void __fastcall FileSaveAs();
    void __fastcall FileSave();
    void __fastcall FileSaveAll();
    void __fastcall FileClose();
    void __fastcall FileCloseAll();


    void __fastcall Undo();
    void __fastcall Redo();

    void __fastcall Cut();
    void __fastcall Copy();
    void __fastcall Paste();

    void __fastcall Delete();
    void __fastcall SelectAll();

	void __fastcall Find();
   	void __fastcall Replace();
    void __fastcall SearchAgain();

    void __fastcall PrinterSetup();
    void __fastcall FilePrint();

    void __fastcall InsertFile(AnsiString FileName);
    void __fastcall PutEditorWindow(int top);

    void __fastcall AppIdle(TObject* Sender, bool& Done  ); // the application->onidle proc

    void __fastcall UpdateControls();

    TRichEdit* __fastcall CurrentRichEdit(void);
    void __fastcall SetRichEditFont(TRichEdit* NewRE);



	__fastcall TForm2(TComponent* Owner);

BEGIN_MESSAGE_MAP
  MESSAGE_HANDLER(WM_GETMINMAXINFO, TWMGetMinMaxInfo, OnGetMinMaxInfo)
END_MESSAGE_MAP(TForm)

};
//---------------------------------------------------------------------------
extern TForm2 *Form2;
//---------------------------------------------------------------------------
#endif
